VERSION 5.00
Begin VB.Form MainForm 
   Caption         =   "MainForm"
   ClientHeight    =   4200
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   6180
   LinkTopic       =   "Form1"
   ScaleHeight     =   4200
   ScaleWidth      =   6180
   StartUpPosition =   2  'CenterScreen
   Begin VB.CommandButton TestCommand 
      Caption         =   "Test"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   495
      Left            =   4080
      TabIndex        =   0
      Top             =   2880
      Width           =   1095
   End
End
Attribute VB_Name = "MainForm"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False

Private Type FTC_INPUT_OUTPUT_PINS
    bPin1InputOutputState As Long 'Boolean
    bPin1LowHighState As Long 'Boolean
    bPin2InputOutputState As Long 'Boolean
    bPin2LowHighState As Long 'Boolean
    bPin3InputOutputState As Long 'Boolean
    bPin3LowHighState As Long 'Boolean
    bPin4InputOutputState As Long 'Boolean
    bPin4LowHighState As Long 'Boolean
End Type

Private Type FTC_LOW_HIGH_PINS
    bPin1LowHighState As Long 'Boolean
    bPin2LowHighState As Long 'Boolean
    bPin3LowHighState As Long 'Boolean
    bPin4LowHighState As Long 'Boolean
End Type

Private Declare Function JTAG_GetNumDevices Lib "ftcjtag" (ByRef NumDevices As Long) As Long
Private Declare Function JTAG_GetDeviceNameLocID Lib "ftcjtag" (ByVal DeviceNameIndex As Long, ByVal DeviceName As String, ByVal BufferSize As Long, ByRef lpLocationID As Long) As Long
Private Declare Function JTAG_OpenEx Lib "ftcjtag" (ByVal DeviceName As String, ByVal LocationID As Long, ByRef ftHandle As Long) As Long
Private Declare Function JTAG_Open Lib "ftcjtag" (ByRef ftHandle As Long) As Long
Private Declare Function JTAG_Close Lib "ftcjtag" (ByVal ftHandle As Long) As Long
Private Declare Function JTAG_InitDevice Lib "ftcjtag" (ByVal ftHandle As Long, ByVal ClockDivisor As Long) As Long
Private Declare Function JTAG_GetClock Lib "ftcjtag" (ByVal ClockDivisor As Long, ByRef lpClockFrequencyHz As Long) As Long
Private Declare Function JTAG_SetClock Lib "ftcjtag" (ByVal ftHandle As Long, ByVal ClockDivisor As Long, ByRef lpClockFrequencyHz As Long) As Long
Private Declare Function JTAG_SetLoopback Lib "ftcjtag" (ByVal ftHandle As Long, ByVal bLoopbackState As Boolean) As Long
Private Declare Function JTAG_SetGPIOs Lib "ftcjtag" (ByVal ftHandle As Long, ByVal bControlLowInputOutputPins As Boolean, ByRef pLowInputOutputPinsData As FTC_INPUT_OUTPUT_PINS, ByVal bControlHighInputOutputPins As Boolean, ByRef pHighInputOutputPinsData As FTC_INPUT_OUTPUT_PINS) As Long
Private Declare Function JTAG_GetGPIOs Lib "ftcjtag" (ByVal ftHandle As Long, ByVal bControlLowInputOutputPins As Boolean, ByRef pLowPinsInputData As FTC_LOW_HIGH_PINS, ByVal bControlHighInputOutputPins As Boolean, ByRef pHighPinsInputData As FTC_LOW_HIGH_PINS) As Long
Private Declare Function JTAG_Write Lib "ftcjtag" (ByVal ftHandle As Long, ByVal bInstructionTestData As Boolean, ByVal NumBitsToWrite As Long, WriteDataBuffer As Any, ByVal NumBytesToWrite As Long, ByVal TapControllerState As Long) As Long
Private Declare Function JTAG_Read Lib "ftcjtag" (ByVal ftHandle As Long, ByVal bInstructionTestData As Boolean, ByVal NumBitsToRead As Long, ReadDataBuffer As Any, ByRef lpNumBytesReturned As Long, ByVal TapControllerState As Long) As Long
Private Declare Function JTAG_WriteRead Lib "ftcjtag" (ByVal ftHandle As Long, ByVal bInstructionTestData As Boolean, ByVal NumBitsToWriteRead As Long, WriteDataBuffer As Any, ByVal NumBytesToWrite As Long, ReadDataBuffer As Any, ByRef lpNumBytesReturned As Long, ByVal TapControllerState As Long) As Long
Private Declare Function JTAG_ClearCmdSequence Lib "ftcjtag" () As Long
Private Declare Function JTAG_AddWriteCmd Lib "ftcjtag" (ByVal bInstructionTestData As Boolean, ByVal NumBitsToWrite As Long, WriteDataBuffer As Any, ByVal NumBytesToWrite As Long, ByVal TapControllerState As Long) As Long
Private Declare Function JTAG_AddReadCmd Lib "ftcjtag" (ByVal bInstructionTestData As Boolean, ByVal NumBitsToRead As Long, ByVal TapControllerState As Long) As Long
Private Declare Function JTAG_AddWriteReadCmd Lib "ftcjtag" (ByVal bInstructionTestData As Boolean, ByVal NumBitsToWriteRead As Long, WriteDataBuffer As Any, ByVal NumBytesToWrite As Long, ByVal TapControllerState As Long) As Long
Private Declare Function JTAG_ClearDeviceCmdSequence Lib "ftcjtag" (ByVal ftHandle As Long) As Long
Private Declare Function JTAG_AddDeviceWriteCmd Lib "ftcjtag" (ByVal ftHandle As Long, ByVal bInstructionTestData As Boolean, ByVal NumBitsToWrite As Long, WriteDataBuffer As Any, ByVal NumBytesToWrite As Long, ByVal TapControllerState As Long) As Long
Private Declare Function JTAG_AddDeviceReadCmd Lib "ftcjtag" (ByVal ftHandle As Long, ByVal bInstructionTestData As Boolean, ByVal NumBitsToRead As Long, ByVal TapControllerState As Long) As Long
Private Declare Function JTAG_AddDeviceWriteReadCmd Lib "ftcjtag" (ByVal ftHandle As Long, ByVal bInstructionTestData As Boolean, ByVal NumBitsToWriteRead As Long, WriteDataBuffer As Any, ByVal NumBytesToWrite As Long, ByVal TapControllerState As Long) As Long
Private Declare Function JTAG_ExecuteCmdSequence Lib "ftcjtag" (ByVal ftHandle As Long, ReadCmdSequenceDataBuffer As Any, ByRef lpNumBytesReturned As Long) As Long
Private Declare Function JTAG_GetDllVersion Lib "ftcjtag" (ByVal DllVersion As String, ByVal BufferSize As Long) As Long
Private Declare Function JTAG_GetErrorCodeString Lib "ftcjtag" (ByVal Language As String, ByVal StatusCode As Long, ByVal ErrorMessage As String, ByVal BufferSize As Long) As Long

Private Declare Function Sleep Lib "Kernel32" (ByVal Milliseconds As Integer) As Long

Private Const FTC_SUCCESS = 0

Private Const TEST_LOGIC_STATE = 1
Private Const RUN_TEST_IDLE_STATE = 2
Private Const PAUSE_TEST_DATA_REGISTER_STATE = 3
Private Const PAUSE_INSTRUCTION_REGISTER_STATE = 4
Private Const SHIFT_TEST_DATA_REGISTER_STATE = 5
Private Const SHIFT_INSTRUCTION_REGISTER_STATE = 6

Private Const WRITE_DATA_BUFFER_SIZE = 65536
Private Const READ_DATA_BUFFER_SIZE = 65536
Private Const READ_CMDS_DATA_BUFFER_SIZE = 131071

Private Const MAX_NUM_DEVICE_NAME_CHARS = 100

Private Const MAX_NUM_DLL_VERSION_CHARS = 10
    
Private Const MAX_NUM_ERROR_MESSAGE_CHARS = 100
    
Private Const App_Title = "FT2232C Device Visual Basic V6.0 Test Application"
    
Private ftHandle As Long
Private Sub Form_Load()

    MainForm.Caption = App_Title
    
    ftHandle = 0
End Sub
Private Sub Form_Unload(Cancel As Integer)
        Dim ftStatus As Long
        
        ftStatus = DS_SUCCESS

        If (ftHandle <> 0) Then
            ftStatus = JTAG_Close(ftHandle)
        End If
End Sub
Private Function ConvertDLLStringToVBString(ByRef DLLString As String) As String
    Dim VBString As String
    Dim DllCharCntr As Long
    Dim VBCharCntr As Long
    Dim DLLStrCharArray() As Byte
    Dim VBStrCharArray() As Byte
        
    DllCharCntr = 0

    DLLStrCharArray = StrConv(DLLString, vbFromUnicode)   ' Convert string.

    While (DLLStrCharArray(DllCharCntr) <> 0)
        DllCharCntr = DllCharCntr + 1
    Wend
        
    ReDim VBStrCharArray(0 To (DllCharCntr - 1)) As Byte
    For VBCharCntr = 0 To (DllCharCntr - 1)
        VBStrCharArray(VBCharCntr) = DLLStrCharArray(VBCharCntr)
    Next

    ConvertDLLStringToVBString = StrConv(VBStrCharArray, vbUnicode)
End Function

Private Sub TestCommand_Click()
    Dim ftStatus As Integer
    Dim NumDevices As Long
    Dim DeviceName As String
    Dim DN As String
    Dim LocationID As Long
    Dim ClockFrequencyHz As Long
    Dim bLoopbackState As Boolean
    Dim LowInputOutputPinsData As FTC_INPUT_OUTPUT_PINS
    Dim HighInputOutputPinsData As FTC_INPUT_OUTPUT_PINS
    Dim LowPinsInputData As FTC_LOW_HIGH_PINS
    Dim HighPinsInputData As FTC_LOW_HIGH_PINS
    Dim WriteDataBuffer((WRITE_DATA_BUFFER_SIZE - 1)) As Byte
    Dim ReadDataBuffer((READ_DATA_BUFFER_SIZE - 1)) As Byte
    Dim ReadCmdSequenceDataBuffer((READ_CMDS_DATA_BUFFER_SIZE - 1)) As Byte
    Dim NumBytesReturned As Long
    Dim iLoopCntr As Integer
    Dim bPerformCommandSequence As Boolean
    Dim ErrorMessage As String
    'Dim DllVersion As String
        
    ftStatus = FTC_SUCCESS
    NumDevices = 0
    DeviceName = String$(MAX_NUM_DEVICE_NAME_CHARS, Chr(0))
    LocationID = 0
    ClockFrequencyHz = 0
    bLoopbackState = False
    NumBytesReturned = 0
    iLoopCntr = 0
    bPerformCommandSequence = False
    
    ErrorMessage = String$(MAX_NUM_ERROR_MESSAGE_CHARS, ChrW(0))
    
    'DllVersion = String$(MAX_NUM_DLL_VERSION_CHARS, Chr(0))
    'ftStatus = JTAG_GetDllVersion(DllVersion, MAX_NUM_DLL_VERSION_CHARS)
    'MsgBox (DllVersion)

    ftStatus = JTAG_GetNumDevices(NumDevices)

    If ((ftStatus = FTC_SUCCESS) And (NumDevices > 0)) Then
        If (NumDevices = 1) Then
            ftStatus = JTAG_GetDeviceNameLocID(0, DeviceName, MAX_NUM_DEVICE_NAME_CHARS, LocationID)

            If (ftStatus = FTC_SUCCESS) Then
                DN = ConvertDLLStringToVBString(DeviceName)
                
                ftStatus = JTAG_OpenEx(DN, LocationID, ftHandle)
            End If

            'ftStatus = JTAG_Open(ftHandle)
        Else
            If (NumDevices = 2) Then
                ftStatus = JTAG_GetDeviceNameLocID(1, DeviceName, MAX_NUM_DEVICE_NAME_CHARS, LocationID)
                   
                If (ftStatus = FTC_SUCCESS) Then
                    DN = ConvertDLLStringToVBString(DeviceName)
                    ftStatus = JTAG_OpenEx(DN, LocationID, ftHandle)
                End If

                'ftStatus = JTAG_Open(ftHandle)
            End If
        End If

        If ((ftHandle <> 0) And (ftStatus = FTC_SUCCESS)) Then
            ftStatus = JTAG_InitDevice(ftHandle, 0)

            If (ftStatus = FTC_SUCCESS) Then
                ftStatus = JTAG_GetClock(0, ClockFrequencyHz)
            End If

            'If (ftStatus = FTC_SUCCESS) Then
            'ftStatus = JTAG_SetLoopback(ftHandle, False)
            'End If

            If (ftStatus = FTC_SUCCESS) Then
                LowInputOutputPinsData.bPin1InputOutputState = True
                LowInputOutputPinsData.bPin2InputOutputState = True
                LowInputOutputPinsData.bPin3InputOutputState = True
                LowInputOutputPinsData.bPin4InputOutputState = True
                LowInputOutputPinsData.bPin1LowHighState = True
                LowInputOutputPinsData.bPin2LowHighState = True
                LowInputOutputPinsData.bPin3LowHighState = True
                LowInputOutputPinsData.bPin4LowHighState = True

                HighInputOutputPinsData.bPin1InputOutputState = True
                HighInputOutputPinsData.bPin2InputOutputState = True
                HighInputOutputPinsData.bPin3InputOutputState = True
                HighInputOutputPinsData.bPin4InputOutputState = True
                HighInputOutputPinsData.bPin1LowHighState = True
                HighInputOutputPinsData.bPin2LowHighState = True
                HighInputOutputPinsData.bPin3LowHighState = True
                HighInputOutputPinsData.bPin4LowHighState = False

                ftStatus = JTAG_SetGPIOs(ftHandle, True, LowInputOutputPinsData, True, HighInputOutputPinsData)

                If (ftStatus = FTC_SUCCESS) Then
                    ftStatus = JTAG_GetGPIOs(ftHandle, True, LowPinsInputData, True, HighPinsInputData)
                End If

                If (ftStatus = FTC_SUCCESS) Then
                    ftStatus = JTAG_SetClock(ftHandle, 1, ClockFrequencyHz)
                End If

                If (ftStatus = FTC_SUCCESS) Then
                    bPerformCommandSequence = True

                    If (bPerformCommandSequence = False) Then
                        Do
                            ftStatus = JTAG_Write(ftHandle, True, 32, WriteDataBuffer(0), 4, RUN_TEST_IDLE_STATE)

                            If (ftStatus = FTC_SUCCESS) Then
                                Sleep (10)

                                ftStatus = JTAG_Read(ftHandle, True, 32, ReadDataBuffer(0), NumBytesReturned, RUN_TEST_IDLE_STATE)

                                If (ftStatus = FTC_SUCCESS) Then
                                    ftStatus = JTAG_WriteRead(ftHandle, True, 32, WriteDataBuffer(0), 4, ReadDataBuffer(0), NumBytesReturned, RUN_TEST_IDLE_STATE)
                                End If
                            End If
                            iLoopCntr = iLoopCntr + 1
                        Loop While (iLoopCntr < 20)
                    Else
                        If (NumDevices = 1) Then
                            ftStatus = JTAG_ClearCmdSequence()

                            Do
                                WriteDataBuffer(0) = &H0
                                WriteDataBuffer(1) = &H0
                                WriteDataBuffer(2) = &H0
                                WriteDataBuffer(3) = &H0
                                ftStatus = JTAG_AddWriteCmd(True, 32, WriteDataBuffer(0), 4, RUN_TEST_IDLE_STATE)

                                If (ftStatus = FTC_SUCCESS) Then
                                    ftStatus = JTAG_AddReadCmd(True, 32, RUN_TEST_IDLE_STATE)
                                End If

                                If (ftStatus = FTC_SUCCESS) Then
                                    ftStatus = JTAG_AddWriteReadCmd(True, 32, WriteDataBuffer(0), 4, RUN_TEST_IDLE_STATE)
                                End If

                                iLoopCntr = iLoopCntr + 1
                            Loop While ((iLoopCntr < 4) And (ftStatus = FTC_SUCCESS))
                        
                        Else
                            ftStatus = JTAG_ClearDeviceCmdSequence(ftHandle)

                            Do
                                WriteDataBuffer(0) = &H0
                                WriteDataBuffer(1) = &H0
                                WriteDataBuffer(2) = &H0
                                WriteDataBuffer(3) = &H0
                                ftStatus = JTAG_AddDeviceWriteCmd(ftHandle, True, 32, WriteDataBuffer(0), 4, RUN_TEST_IDLE_STATE)

                                If (ftStatus = FTC_SUCCESS) Then
                                    ftStatus = JTAG_AddDeviceReadCmd(ftHandle, True, 32, RUN_TEST_IDLE_STATE)
                                End If

                                If (ftStatus = FTC_SUCCESS) Then
                                    ftStatus = JTAG_AddDeviceWriteReadCmd(ftHandle, True, 32, WriteDataBuffer(0), 4, RUN_TEST_IDLE_STATE)
                                End If

                                iLoopCntr = iLoopCntr + 1
                            Loop While ((iLoopCntr < 4) And (ftStatus = FTC_SUCCESS))
                        End If
                        
                        If (ftStatus = FTC_SUCCESS) Then
                             ftStatus = JTAG_ExecuteCmdSequence(ftHandle, ReadCmdSequenceDataBuffer(0), NumBytesReturned)
                        End If
                    End If
                End If

                JTAG_Close (ftHandle)
                ftHandle = 0
            End If
        End If
    End If

    If (ftStatus <> FTC_SUCCESS) Then
        ftStatus = JTAG_GetErrorCodeString("EN", ftStatus, ErrorMessage, MAX_NUM_ERROR_MESSAGE_CHARS)

        MsgBox (ErrorMessage)
    End If
End Sub
